<template>
  <div>
    <the-hero
      title="Table2CSV"
      subtitle="Extracting html tables">
      <b-field grouped>
        <b-input placeholder="Search..."
          icon="magnify"
          v-model="url" expanded>
        </b-input>
        <p class="control">
          <button class="button is-primary" v-on:click="onePage">Search</button>
        </p>
      </b-field>

      <b-collapse :open="false" aria-id="contentIdForA11y1">
        <span slot="trigger"
          aria-controls="contentIdForA11y1">
          Avanzado
        </span>

        <div class="notification">
          <div class="content">
            <b-field grouped>
              <b-field label="Query string">
                <b-input v-model="queryString"></b-input>
              </b-field>

              <b-field label="Desde" type="number">
                <b-input v-model="pageStart"></b-input>
              </b-field>

              <b-field label="Hasta" type="number">
                <b-input v-model="pageEnd"></b-input>
              </b-field>

              <p class="control">
                <button class="button is-primary" v-on:click="multiplePage">Search</button>
              </p>
            </b-field>

          </div>
        </div>
      </b-collapse>

      <b-progress v-if="startScraper"
        type="is-success" :value="progress" size="is-large" show-value>
        {{ downloadPages }} pages of {{ totalPages }}
      </b-progress>
    </the-hero>

    <section id="data">
      <div v-if="data.length !== 0" class="container has-text-centered">
        <b-table
          :data="data"
          :columns="columns"
          :per-page="perPage"
          :paginated="isPaginated">
        </b-table>

        <button class="button is-primary" v-on:click="dowloadData">Download CSV</button>
      </div>
    </section>
  </div>
</template>

<script>
import TheHero from '~/components/TheHero'

export default {
  head () {
    return {
      bodyAttrs: {
        class: 'table2csv'
      }
    }
  },
  components: {
    TheHero
  },
  data () {
    return {
      startScraper: false,

      // Table scraper data
      perPage: 10,
      isPaginated: true,
      data: [],
      columns: [],

      // Url to scraper
      url: 'https://rdlist.nic.ar/rd_list/',
      queryString: 'page',
      pageStart: 1,
      pageEnd: 50,

      // Pages progress
      progress: 0,
      totalPages: 1,
      downloadPages: 0
    }
  },
  methods: {
    onePage: function () {
      // Scraper one page
      // Restart some vars
      this.progress = 0
      this.totalPages = 1
      this.downloadPages = 0
      this.data = []
      this.columns = []

      this.startScraper = true

      // Get the table
      const query = process.env.serverUrl + this.url
      this.scrape(query)
    },
    multiplePage: function () {
      // Scraper multiple pages
      // Restart some vars
      this.progress = 0
      this.totalPages = this.pageEnd - this.pageStart
      this.downloadPages = 0
      this.data = []
      this.columns = []

      this.startScraper = true

      const url = new URL(this.url)

      // Get the table
      for (let i = this.pageStart; i < this.pageEnd; i++) {
        url.searchParams.set(this.queryString, i)
        const query = process.env.serverUrl + url.href
        this.scrape(query)
      }
    },
    scrape: function (query) {
      // Send the url to scrape to the server
      const xhr = new XMLHttpRequest()
      xhr.open('GET', query)
      xhr.responseType = 'json'

      // On load end
      xhr.addEventListener('load', () => {
        // Update counter
        this.downloadPages += 1
        this.progress = parseInt(this.downloadPages * 100 / this.totalPages)

        // New data
        xhr.response.data.forEach(row => this.data.push(row))
        this.columns = xhr.response.columns.map(d => ({ field: d, label: d }))
      })

      xhr.send()
    },
    dowloadData: function () {
      // Download the table scrapers to CSV
      let csv = ''
      const columns = this.columns.map(col => col.field)

      // CSV header
      csv = columns.join(',')
      csv += '\n'

      // CSV body
      this.data.forEach(row => {
        const partial = columns.map(col => row[col])
        csv += partial.join(',')
        csv += '\n'
      })

      // Create and element to download the CSV
      const hiddenElement = document.createElement('a')
      hiddenElement.href = 'data:text/csv;charset=utf-8,' + encodeURI(csv)
      hiddenElement.target = '_blank'
      hiddenElement.download = 'data.csv'
      hiddenElement.click()
    }
  }
}
</script>
